//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//
//	this file was originally created by Olaf Hartig (9 Nov 1999)
//

#ifndef CConfigDialog_included
#define CConfigDialog_included

#include <qdialog.h>
#include <qevent.h>
#include <qpixmap.h>

class QLineEdit;
class QPushButton;

class CConfigDialog : public QDialog
{
	Q_OBJECT

public:
	CConfigDialog(int nKeyNW, int nKeyNE, int nKeySW, int nKeySE, QWidget * pParent = 0, const char * pszName = 0);
		// nKeyNW - actual keycode for northwest
		// nKeyNE - actual keycode for northeast
		// nKeySW - actual keycode for southwest
		// nKeySE - actual keycode for southeast

	int getKeyNW() const { return m_nActKeys[0]; }
	int getKeyNE() const { return m_nActKeys[1]; }
	int getKeySW() const { return m_nActKeys[2]; }
	int getKeySE() const { return m_nActKeys[3]; }

// added by Holger Priebs (18 Nov 99)

	QPixmap* configpix;
	QPixmap* button_nw;
	QPixmap* button_ne;
	QPixmap* button_sw;
	QPixmap* button_se;

	void paintEvent( QPaintEvent* );

// ------------------------------------

signals:
	void newKeys(int, int, int, int); // 0 - NW; 1 - NE; 2 - SW; 3 - SE

protected:
	bool m_fWaitingForKey;
	int m_nActDirection;
	int m_nActKeys[4]; // 0 - NW; 1 - NE; 2 - SW; 3 - SE

	QLineEdit* m_pLineEdits[4]; // 0 - NW; 1 - NE; 2 - SW; 3 - SE
	QPushButton* m_pDirButtons[4]; // 0 - NW; 1 - NE; 2 - SW; 3 - SE

	QPixmap m_Pixmaps[4]; // 0 - NW; 1 - NE; 2 - SW; 3 - SE

	void keyPressEvent( QKeyEvent* e );
	void pressedDirButton(int nDir); // 0 - NW; 1 - NE; 2 - SW; 3 - SE

protected slots:
	void pressedNWButton() { pressedDirButton(0); }	
	void pressedNEButton() { pressedDirButton(1); }
	void pressedSWButton() { pressedDirButton(2); }
	void pressedSEButton() { pressedDirButton(3); }
	void pressedOKButton();
	void pressedCancelButton();

};

#endif // CConfigDialog_included
